Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -4472,24 +4558,687 @@
  END SUBROUTINE radiation_tendency
 
-
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> This subroutine calculates interaction of the solar radiation
-!> with urban and land surfaces and updates all surface heatfluxes, including
-!> the vertual atmospheric cell faces. It calculates also the required parameters
-!> for RRTMG lower BC.
-!>  
+!> with urban and land surfaces and updates all surface heatfluxes.
+!> It calculates also the required parameters for RRTMG lower BC.
+!>
 !> For more info. see Resler et al. 2017
-!>  
+!>
+!> The new version 2.0 was radically rewriten, the discretization scheme
+!> has been changed. This new version significantly improves effectivity
+!> of the paralelization and the scalability of the model.
+!------------------------------------------------------------------------------!
+
+ SUBROUTINE radiation_interaction
+
+     IMPLICIT NONE
+
+     INTEGER(iwp)                      :: i, j, k, kk, is, js, d, ku, refstep, m, mm, l, ll
+     INTEGER(iwp)                      :: nzubl, nzutl, isurf, isurfsrc, isvf, icsf, ipcgb
+     INTEGER(iwp)                      :: isd                !< solar direction number
+     REAL(wp), DIMENSION(3,3)          :: mrot               !< grid rotation matrix (zyx)
+     REAL(wp), DIMENSION(3,0:nsurf_type):: vnorm             !< face direction normal vectors (zyx)
+     REAL(wp), DIMENSION(3)            :: sunorig            !< grid rotated solar direction unit vector (zyx)
+     REAL(wp), DIMENSION(3)            :: sunorig_grid       !< grid squashed solar direction unit vector (zyx)
+     REAL(wp), DIMENSION(0:nsurf_type) :: costheta           !< direct irradiance factor of solar angle
+     REAL(wp), DIMENSION(nzub:nzut)    :: pchf_prep          !< precalculated factor for canopy temp tendency
+     REAL(wp), PARAMETER               :: alpha = 0._wp      !< grid rotation (TODO: add to namelist or remove)
+     REAL(wp)                          :: pc_box_area, pc_abs_frac, pc_abs_eff
+     INTEGER(iwp)                      :: pc_box_dimshift    !< transform for best accuracy
+     INTEGER(iwp), DIMENSION(0:3)      :: reorder = (/ 1, 0, 3, 2 /)
+     REAL(wp), DIMENSION(0:nsurf_type) :: facearea
+     REAL(wp)                          :: pabsswl  = 0.0_wp  !< total absorbed SW radiation energy in local processor (W)
+     REAL(wp)                          :: pabssw   = 0.0_wp  !< total absorbed SW radiation energy in all processors (W)
+     REAL(wp)                          :: pabslwl  = 0.0_wp  !< total absorbed LW radiation energy in local processor (W)
+     REAL(wp)                          :: pabslw   = 0.0_wp  !< total absorbed LW radiation energy in all processors (W)
+     REAL(wp)                          :: pemitlwl = 0.0_wp  !< total emitted LW radiation energy in all processors (W)
+     REAL(wp)                          :: pemitlw  = 0.0_wp  !< total emitted LW radiation energy in all processors (W)
+     REAL(wp)                          :: pinswl   = 0.0_wp  !< total received SW radiation energy in local processor (W)
+     REAL(wp)                          :: pinsw    = 0.0_wp  !< total received SW radiation energy in all processor (W)
+     REAL(wp)                          :: pinlwl   = 0.0_wp  !< total received LW radiation energy in local processor (W)
+     REAL(wp)                          :: pinlw    = 0.0_wp  !< total received LW radiation energy in all processor (W)
+     REAL(wp)                          :: emiss_sum_surfl    !< sum of emissisivity of surfaces in local processor
+     REAL(wp)                          :: emiss_sum_surf     !< sum of emissisivity of surfaces in all processor
+     REAL(wp)                          :: area_surfl         !< total area of surfaces in local processor
+     REAL(wp)                          :: area_surf          !< total area of surfaces in all processor
+
+#if ! defined( __nopointer )
+     IF ( plant_canopy )  THEN
+         pchf_prep(:) = r_d * (hyp(nzub:nzut) / 100000.0_wp)**0.286_wp &
+                     / (cp * hyp(nzub:nzut) * dx*dy*dz) !< equals to 1 / (rho * c_p * Vbox * T)
+     ENDIF
+#endif
+     sun_direction = .TRUE.
+     CALL calc_zenith  !< required also for diffusion radiation
+
+!--     prepare rotated normal vectors and irradiance factor
+     vnorm(1,:) = kdir(:)
+     vnorm(2,:) = jdir(:)
+     vnorm(3,:) = idir(:)
+     mrot(1, :) = (/ 1._wp,  0._wp,      0._wp      /)
+     mrot(2, :) = (/ 0._wp,  COS(alpha), SIN(alpha) /)
+     mrot(3, :) = (/ 0._wp, -SIN(alpha), COS(alpha) /)
+     sunorig = (/ zenith(0), sun_dir_lat, sun_dir_lon /)
+     sunorig = MATMUL(mrot, sunorig)
+     DO d = 0, nsurf_type
+         costheta(d) = DOT_PRODUCT(sunorig, vnorm(:,d))
+     ENDDO
+
+     IF ( zenith(0) > 0 )  THEN
+!--         now we will "squash" the sunorig vector by grid box size in
+!--         each dimension, so that this new direction vector will allow us
+!--         to traverse the ray path within grid coordinates directly
+         sunorig_grid = (/ sunorig(1)/dz, sunorig(2)/dy, sunorig(3)/dx /)
+!--         sunorig_grid = sunorig_grid / norm2(sunorig_grid)
+         sunorig_grid = sunorig_grid / SQRT(SUM(sunorig_grid**2))
+
+         IF ( plant_canopy )  THEN
+!--            precompute effective box depth with prototype Leaf Area Density
+            pc_box_dimshift = MAXLOC(ABS(sunorig), 1) - 1
+            CALL box_absorb(CSHIFT((/dz,dy,dx/), pc_box_dimshift),      &
+                                60, prototype_lad,                          &
+                                CSHIFT(ABS(sunorig), pc_box_dimshift),      &
+                                pc_box_area, pc_abs_frac)
+            pc_box_area = pc_box_area * ABS(sunorig(pc_box_dimshift+1) / sunorig(1))
+            pc_abs_eff = LOG(1._wp - pc_abs_frac) / prototype_lad
+         ENDIF
+     ENDIF
+
+!--     split diffusion and direct part of the solar downward radiation
+!--     comming from radiation model and store it in 2D arrays
+!--     rad_sw_in_diff, rad_sw_in_dir and rad_lw_in_diff
+     IF ( split_diffusion_radiation )  THEN
+         CALL calc_diffusion_radiation
+     ELSE
+         rad_sw_in_diff = 0.0_wp
+         rad_sw_in_dir(:,:)  = rad_sw_in(0,:,:)
+         rad_lw_in_diff(:,:) = rad_lw_in(0,:,:)
+     ENDIF
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     First pass: direct + diffuse irradiance + thermal
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     surfinswdir   = 0._wp !nsurfl
+     surfins       = 0._wp !nsurfl
+     surfinl       = 0._wp !nsurfl
+     surfoutsl(:)  = 0.0_wp !start-end
+     surfoutll(:)  = 0.0_wp !start-end
+
+!--  Set up thermal radiation from surfaces
+!--  emiss_surf is defined only for surfaces for which energy balance is calculated
+!--  Workaround: reorder surface data type back on 1D array including all surfaces,
+!--  which implies to reorder horizontal and vertical surfaces
+!
+!--  Horizontal walls
+     mm = 1
+     DO  i = nxl, nxr
+        DO  j = nys, nyn
+!--           urban
+           DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+              surfoutll(mm) = SUM ( surf_usm_h%frac(:,m) *                  &
+                                    surf_usm_h%emissivity(:,m) )            &
+                                  * sigma_sb                                &
+                                  * surf_usm_h%pt_surface(m)**4
+              albedo_surf(mm) = SUM ( surf_usm_h%frac(:,m) *                &
+                                      surf_usm_h%albedo(:,m) )
+              emiss_surf(mm)  = SUM ( surf_usm_h%frac(:,m) *                &
+                                      surf_usm_h%emissivity(:,m) )
+              mm = mm + 1
+           ENDDO
+!--           land
+           DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+              surfoutll(mm) = SUM ( surf_lsm_h%frac(:,m) *                  &
+                                    surf_lsm_h%emissivity(:,m) )            &
+                                  * sigma_sb                                &
+                                  * surf_lsm_h%pt_surface(m)**4
+              albedo_surf(mm) = SUM ( surf_lsm_h%frac(:,m) *                &
+                                      surf_lsm_h%albedo(:,m) )
+              emiss_surf(mm)  = SUM ( surf_lsm_h%frac(:,m) *                &
+                                      surf_lsm_h%emissivity(:,m) )
+              mm = mm + 1
+           ENDDO
+        ENDDO
+     ENDDO
+!
+!--     Vertical walls
+     DO  i = nxl, nxr
+        DO  j = nys, nyn
+           DO  ll = 0, 3
+              l = reorder(ll)
+!--              urban
+              DO  m = surf_usm_v(l)%start_index(j,i),                       &
+                      surf_usm_v(l)%end_index(j,i)
+                 surfoutll(mm) = SUM ( surf_usm_v(l)%frac(:,m) *            &
+                                       surf_usm_v(l)%emissivity(:,m) )      &
+                                  * sigma_sb                                &
+                                  * surf_usm_v(l)%pt_surface(m)**4
+                 albedo_surf(mm) = SUM ( surf_usm_v(l)%frac(:,m) *          &
+                                         surf_usm_v(l)%albedo(:,m) )
+                 emiss_surf(mm)  = SUM ( surf_usm_v(l)%frac(:,m) *          &
+                                         surf_usm_v(l)%emissivity(:,m) )
+                 mm = mm + 1
+              ENDDO
+!--              land
+              DO  m = surf_lsm_v(l)%start_index(j,i),                       &
+                      surf_lsm_v(l)%end_index(j,i)
+                 surfoutll(mm) = SUM ( surf_lsm_v(l)%frac(:,m) *            &
+                                       surf_lsm_v(l)%emissivity(:,m) )      &
+                                  * sigma_sb                                &
+                                  * surf_lsm_v(l)%pt_surface(m)**4
+                 albedo_surf(mm) = SUM ( surf_lsm_v(l)%frac(:,m) *          &
+                                         surf_lsm_v(l)%albedo(:,m) )
+                 emiss_surf(mm)  = SUM ( surf_lsm_v(l)%frac(:,m) *          &
+                                         surf_lsm_v(l)%emissivity(:,m) )
+                 mm = mm + 1
+              ENDDO
+           ENDDO
+        ENDDO
+     ENDDO
+
+#if defined( __parallel )
+!--     might be optimized and gather only values relevant for current processor
+     CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
+                         surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr) !nsurf global
+#else
+     surfoutl(:) = surfoutll(:) !nsurf global
+#endif
+
+     DO isvf = 1, nsvfl
+         isurf = svfsurf(1, isvf)
+         k = surfl(iz, isurf)
+         j = surfl(iy, isurf)
+         i = surfl(ix, isurf)
+         isurfsrc = svfsurf(2, isvf)
+
+!--         for surface-to-surface factors we calculate thermal radiation in 1st pass
+         surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
+     ENDDO
+
+     !-- diffuse radiation using sky view factor, TODO: homogeneous rad_*w_in_diff because now it depends on no. of processors
+     surfinswdif(:) = rad_sw_in_diff(nyn,nxl) * skyvft(:)
+     surfinlwdif(:) = rad_lw_in_diff(nyn,nxl) * skyvf(:)
+
+     !-- direct radiation
+     IF ( zenith(0) > 0 )  THEN
+        !--Identify solar direction vector (discretized number) 1)
+        !--
+        j = FLOOR(ACOS(zenith(0)) / pi * raytrace_discrete_elevs)
+        i = MODULO(NINT(ATAN2(sun_dir_lon(0), sun_dir_lat(0))               &
+                        / (2._wp*pi) * raytrace_discrete_azims-.5_wp, iwp), &
+                   raytrace_discrete_azims)
+        isd = dsidir_rev(j, i)
+        DO isurf = 1, nsurfl
+           surfinswdir(isurf) = rad_sw_in_dir(nyn,nxl) * costheta(surfl(id, isurf)) * dsitrans(isurf, isd) / zenith(0)
+        ENDDO
+     ENDIF
+
+     IF ( plant_canopy )  THEN
+
+         pcbinswdir(:) = 0._wp
+         pcbinswdif(:) = 0._wp
+         pcbinlw(:) = 0._wp  !< will stay always 0 since we don't absorb lw anymore
+!
+!--         pcsf first pass
+         DO icsf = 1, ncsfl
+             ipcgb = csfsurf(1, icsf)
+             i = pcbl(ix,ipcgb)
+             j = pcbl(iy,ipcgb)
+             k = pcbl(iz,ipcgb)
+             isurfsrc = csfsurf(2, icsf)
+
+             IF ( isurfsrc == -1 )  THEN
+!--                 Diffuse rad from sky.
+                 pcbinswdif(ipcgb) = csf(1,icsf) * csf(2,icsf) * rad_sw_in_diff(j,i)
+
+                 !--Direct rad
+                 IF ( zenith(0) > 0 )  THEN
+                    !--Estimate directed box absorption
+                    pc_abs_frac = 1._wp - exp(pc_abs_eff * lad_s(k,j,i))
+
+                    !--isd has already been established, see 1)
+                    pcbinswdir(ipcgb) = rad_sw_in_dir(j, i) * pc_box_area &
+                                        * pc_abs_frac * dsitransc(ipcgb, isd)
+                 ENDIF
+
+                 EXIT ! only isurfsrc=-1 is processed here
+             ENDIF
+         ENDDO
+
+         pcbinsw(:) = pcbinswdir(:) + pcbinswdif(:)
+     ENDIF
+     surfins = surfinswdir + surfinswdif
+     surfinl = surfinl + surfinlwdif
+     surfinsw = surfins
+     surfinlw = surfinl
+     surfoutsw = 0.0_wp
+     surfoutlw = surfoutll
+!        surfhf = surfinsw + surfinlw - surfoutsw - surfoutlw
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!--     Next passes - reflections
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     DO refstep = 1, nrefsteps
+
+         surfoutsl = albedo_surf * surfins
+!--         for non-transparent surfaces, longwave albedo is 1 - emissivity
+         surfoutll = (1._wp - emiss_surf) * surfinl
+
+#if defined( __parallel )
+         CALL MPI_AllGatherv(surfoutsl, nsurfl, MPI_REAL, &
+             surfouts, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+         CALL MPI_AllGatherv(surfoutll, nsurfl, MPI_REAL, &
+             surfoutl, nsurfs, surfstart, MPI_REAL, comm2d, ierr)
+#else
+         surfouts = surfoutsl
+         surfoutl = surfoutll
+#endif
+
+!--         reset for next pass input
+         surfins = 0._wp
+         surfinl = 0._wp
+
+!--         reflected radiation
+         DO isvf = 1, nsvfl
+             isurf = svfsurf(1, isvf)
+             isurfsrc = svfsurf(2, isvf)
+             surfins(isurf) = surfins(isurf) + svf(1,isvf) * svf(2,isvf) * surfouts(isurfsrc)
+             surfinl(isurf) = surfinl(isurf) + svf(1,isvf) * surfoutl(isurfsrc)
+         ENDDO
+
+!--         radiation absorbed by plant canopy
+         DO icsf = 1, ncsfl
+             ipcgb = csfsurf(1, icsf)
+             isurfsrc = csfsurf(2, icsf)
+             IF ( isurfsrc == -1 )  CYCLE ! sky->face only in 1st pass, not here
+
+             pcbinsw(ipcgb) = pcbinsw(ipcgb) + csf(1,icsf) * csf(2,icsf) * surfouts(isurfsrc)
+         ENDDO
+
+         surfinsw = surfinsw  + surfins
+         surfinlw = surfinlw  + surfinl
+         surfoutsw = surfoutsw + surfoutsl
+         surfoutlw = surfoutlw + surfoutll
+!            surfhf = surfinsw + surfinlw - surfoutsw - surfoutlw
+
+     ENDDO
+
+!--  push heat flux absorbed by plant canopy to respective 3D arrays
+     IF ( plant_canopy )  THEN
+         pc_heating_rate(:,:,:) = 0._wp
+         DO ipcgb = 1, npcbl
+                 
+             j = pcbl(iy, ipcgb)
+             i = pcbl(ix, ipcgb)
+             k = pcbl(iz, ipcgb)
+!
+!--             Following expression equals former kk = k - nzb_s_inner(j,i)
+             kk = k - get_topography_top_index_ji( j, i, 's' )  !- lad arrays are defined flat
+             pc_heating_rate(kk, j, i) = (pcbinsw(ipcgb) + pcbinlw(ipcgb)) &
+                 * pchf_prep(k) * pt(k, j, i) !-- = dT/dt
+         ENDDO
+     ENDIF
+!
+!--     Transfer radiation arrays required for energy balance to the respective data types
+     DO  i = 1, nsurfl
+        m  = surfl(5,i)
+!
+!--     (1) Urban surfaces
+!--     upward-facing
+        IF ( surfl(1,i) == iup_u )  THEN
+           surf_usm_h%rad_sw_in(m)  = surfinsw(i)
+           surf_usm_h%rad_sw_out(m) = surfoutsw(i)
+           surf_usm_h%rad_lw_in(m)  = surfinlw(i)
+           surf_usm_h%rad_lw_out(m) = surfoutlw(i)
+           surf_usm_h%rad_net(m)    = surfinsw(i) - surfoutsw(i) +          &
+                                      surfinlw(i) - surfoutlw(i)
+!
+!--     northward-facding
+        ELSEIF ( surfl(1,i) == inorth_u )  THEN
+           surf_usm_v(0)%rad_sw_in(m)  = surfinsw(i)
+           surf_usm_v(0)%rad_sw_out(m) = surfoutsw(i)
+           surf_usm_v(0)%rad_lw_in(m)  = surfinlw(i)
+           surf_usm_v(0)%rad_lw_out(m) = surfoutlw(i)
+           surf_usm_v(0)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     southward-facding
+        ELSEIF ( surfl(1,i) == isouth_u )  THEN
+           surf_usm_v(1)%rad_sw_in(m)  = surfinsw(i)
+           surf_usm_v(1)%rad_sw_out(m) = surfoutsw(i)
+           surf_usm_v(1)%rad_lw_in(m)  = surfinlw(i)
+           surf_usm_v(1)%rad_lw_out(m) = surfoutlw(i)
+           surf_usm_v(1)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     eastward-facing
+        ELSEIF ( surfl(1,i) == ieast_u )  THEN
+           surf_usm_v(2)%rad_sw_in(m)  = surfinsw(i)
+           surf_usm_v(2)%rad_sw_out(m) = surfoutsw(i)
+           surf_usm_v(2)%rad_lw_in(m)  = surfinlw(i)
+           surf_usm_v(2)%rad_lw_out(m) = surfoutlw(i)
+           surf_usm_v(2)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     westward-facding
+        ELSEIF ( surfl(1,i) == iwest_u )  THEN
+           surf_usm_v(3)%rad_sw_in(m)  = surfinsw(i)
+           surf_usm_v(3)%rad_sw_out(m) = surfoutsw(i)
+           surf_usm_v(3)%rad_lw_in(m)  = surfinlw(i)
+           surf_usm_v(3)%rad_lw_out(m) = surfoutlw(i)
+           surf_usm_v(3)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     (2) land surfaces
+!--     upward-facing
+        ELSEIF ( surfl(1,i) == iup_l )  THEN
+           surf_lsm_h%rad_sw_in(m)  = surfinsw(i)
+           surf_lsm_h%rad_sw_out(m) = surfoutsw(i)
+           surf_lsm_h%rad_lw_in(m)  = surfinlw(i)
+           surf_lsm_h%rad_lw_out(m) = surfoutlw(i)
+           surf_lsm_h%rad_net(m)    = surfinsw(i) - surfoutsw(i) +          &
+                                      surfinlw(i) - surfoutlw(i)
+!
+!--     northward-facding
+        ELSEIF ( surfl(1,i) == inorth_l )  THEN
+           surf_lsm_v(0)%rad_sw_in(m)  = surfinsw(i)
+           surf_lsm_v(0)%rad_sw_out(m) = surfoutsw(i)
+           surf_lsm_v(0)%rad_lw_in(m)  = surfinlw(i)
+           surf_lsm_v(0)%rad_lw_out(m) = surfoutlw(i)
+           surf_lsm_v(0)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     southward-facding
+        ELSEIF ( surfl(1,i) == isouth_l )  THEN
+           surf_lsm_v(1)%rad_sw_in(m)  = surfinsw(i)
+           surf_lsm_v(1)%rad_sw_out(m) = surfoutsw(i)
+           surf_lsm_v(1)%rad_lw_in(m)  = surfinlw(i)
+           surf_lsm_v(1)%rad_lw_out(m) = surfoutlw(i)
+           surf_lsm_v(1)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     eastward-facing
+        ELSEIF ( surfl(1,i) == ieast_l )  THEN
+           surf_lsm_v(2)%rad_sw_in(m)  = surfinsw(i)
+           surf_lsm_v(2)%rad_sw_out(m) = surfoutsw(i)
+           surf_lsm_v(2)%rad_lw_in(m)  = surfinlw(i)
+           surf_lsm_v(2)%rad_lw_out(m) = surfoutlw(i)
+           surf_lsm_v(2)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+!
+!--     westward-facing
+        ELSEIF ( surfl(1,i) == iwest_l )  THEN
+           surf_lsm_v(3)%rad_sw_in(m)  = surfinsw(i)
+           surf_lsm_v(3)%rad_sw_out(m) = surfoutsw(i)
+           surf_lsm_v(3)%rad_lw_in(m)  = surfinlw(i)
+           surf_lsm_v(3)%rad_lw_out(m) = surfoutlw(i)
+           surf_lsm_v(3)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
+                                         surfinlw(i) - surfoutlw(i)
+        ENDIF
+
+     ENDDO
+
+     DO  m = 1, surf_usm_h%ns
+        surf_usm_h%surfhf(m) = surf_usm_h%rad_sw_in(m)  +                   &
+                               surf_usm_h%rad_lw_in(m)  -                   &
+                               surf_usm_h%rad_sw_out(m) -                   &
+                               surf_usm_h%rad_lw_out(m)
+     ENDDO
+     DO  m = 1, surf_lsm_h%ns
+        surf_lsm_h%surfhf(m) = surf_lsm_h%rad_sw_in(m)  +                   &
+                               surf_lsm_h%rad_lw_in(m)  -                   &
+                               surf_lsm_h%rad_sw_out(m) -                   &
+                               surf_lsm_h%rad_lw_out(m)
+     ENDDO
+
+     DO  l = 0, 3
+!--     urban
+        DO  m = 1, surf_usm_v(l)%ns
+           surf_usm_v(l)%surfhf(m) = surf_usm_v(l)%rad_sw_in(m)  +          &
+                                     surf_usm_v(l)%rad_lw_in(m)  -          &
+                                     surf_usm_v(l)%rad_sw_out(m) -          &
+                                     surf_usm_v(l)%rad_lw_out(m)
+        ENDDO
+!--     land
+        DO  m = 1, surf_lsm_v(l)%ns
+           surf_lsm_v(l)%surfhf(m) = surf_lsm_v(l)%rad_sw_in(m)  +          &
+                                     surf_lsm_v(l)%rad_lw_in(m)  -          &
+                                     surf_lsm_v(l)%rad_sw_out(m) -          &
+                                     surf_lsm_v(l)%rad_lw_out(m)
+
+        ENDDO
+     ENDDO
+!
+!--  Calculate the average temperature, albedo, and emissivity for urban/land
+!--  domain when using average_radiation in the respective radiation model
+
+     IF ( average_radiation )  THEN
+
+!--     precalculate face areas for all face directions using normal vector
+        DO d = 0, nsurf_type
+            facearea(d) = 1._wp
+            IF ( idir(d) == 0 ) facearea(d) = facearea(d) * dx
+            IF ( jdir(d) == 0 ) facearea(d) = facearea(d) * dy
+            IF ( kdir(d) == 0 ) facearea(d) = facearea(d) * dz
+        ENDDO
+!
+!--     absorbed/received SW & LW and emitted LW energy of all physical
+!--     surfaces (land and urban) in local processor
+        pinswl = 0._wp
+        pinlwl = 0._wp
+        pabsswl = 0._wp
+        pabslwl = 0._wp
+        pemitlwl = 0._wp
+        emiss_sum_surfl = 0._wp
+        area_surfl = 0._wp
+        DO  i = 1, nsurfl
+           d = surfl(id, i)
+!--        received SW & LW
+           pinswl = pinswl + surfinsw(i) * facearea(d)
+           pinlwl = pinlwl + surfinlw(i) * facearea(d)
+!--        absorbed SW & LW
+           pabsswl = pabsswl + (1._wp - albedo_surf(i)) *                   &
+                                                  surfinsw(i) * facearea(d)
+           pabslwl = pabslwl + emiss_surf(i) * surfinlw(i) * facearea(d)
+!--        emitted LW
+           pemitlwl = pemitlwl + surfoutlw(i) * facearea(d)
+!--        emissivity and area sum
+           emiss_sum_surfl = emiss_sum_surfl + emiss_surf(i) * facearea(d)
+           area_surfl = area_surfl + facearea(d)
+        END DO
+!
+!--     add the absorbed SW energy by plant canopy
+        IF ( plant_canopy )  THEN
+           pabsswl = pabsswl + SUM(pcbinsw)
+           pabslwl = pabslwl + SUM(pcbinlw)
+        ENDIF
+!
+!--     gather all rad flux energy in all processors
+#if defined( __parallel )
+        CALL MPI_ALLREDUCE( pinswl, pinsw, 1, MPI_REAL, MPI_SUM, comm2d, ierr)
+        CALL MPI_ALLREDUCE( pinlwl, pinlw, 1, MPI_REAL, MPI_SUM, comm2d, ierr)
+        CALL MPI_ALLREDUCE( pabsswl, pabssw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+        CALL MPI_ALLREDUCE( pabslwl, pabslw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+        CALL MPI_ALLREDUCE( pemitlwl, pemitlw, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+        CALL MPI_ALLREDUCE( emiss_sum_surfl, emiss_sum_surf, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+        CALL MPI_ALLREDUCE( area_surfl, area_surf, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+        pinsw = pinswl
+        pinlw = pinlwl
+        pabssw = pabsswl
+        pabslwl = pabslw
+        pemitlwl = pemitlw
+        emiss_sum_surf = emiss_sum_surfl
+        area_surf = area_surfl
+#endif
+
+!--     (1) albedo
+        IF ( pinsw /= 0.0_wp )  albedo_urb = 1._wp - pabssw / pinsw
+
+!--     (2) average emmsivity
+        IF ( area_surf /= 0.0_wp ) emissivity_urb = emiss_sum_surf / area_surf
+
+!--     (3) temperature
+        t_rad_urb = ((pemitlw - pabslw + emissivity_urb*pinlw)/(emissivity_urb*sigma_sb*area_surf))**0.25_wp
+
+     ENDIF
+
+    CONTAINS
+
+!------------------------------------------------------------------------------!
+!> Calculates radiation absorbed by box with given size and LAD.
+!>
+!> Simulates resol**2 rays (by equally spacing a bounding horizontal square
+!> conatining all possible rays that would cross the box) and calculates
+!> average transparency per ray. Returns fraction of absorbed radiation flux
+!> and area for which this fraction is effective.
+!------------------------------------------------------------------------------!
+    PURE SUBROUTINE box_absorb(boxsize, resol, dens, uvec, area, absorb)
+       IMPLICIT NONE
+
+       REAL(wp), DIMENSION(3), INTENT(in) :: &
+            boxsize, &      !< z, y, x size of box in m
+            uvec            !< z, y, x unit vector of incoming flux
+       INTEGER(iwp), INTENT(in) :: &
+            resol           !< No. of rays in x and y dimensions
+       REAL(wp), INTENT(in) :: &
+            dens            !< box density (e.g. Leaf Area Density)
+       REAL(wp), INTENT(out) :: &
+            area, &         !< horizontal area for flux absorbtion
+            absorb          !< fraction of absorbed flux
+       REAL(wp) :: &
+            xshift, yshift, &
+            xmin, xmax, ymin, ymax, &
+            xorig, yorig, &
+            dx1, dy1, dz1, dx2, dy2, dz2, &
+            crdist, &
+            transp
+       INTEGER(iwp) :: &
+            i, j
+
+       xshift = uvec(3) / uvec(1) * boxsize(1)
+       xmin = min(0._wp, -xshift)
+       xmax = boxsize(3) + max(0._wp, -xshift)
+       yshift = uvec(2) / uvec(1) * boxsize(1)
+       ymin = min(0._wp, -yshift)
+       ymax = boxsize(2) + max(0._wp, -yshift)
+
+       transp = 0._wp
+       DO i = 1, resol
+          xorig = xmin + (xmax-xmin) * (i-.5_wp) / resol
+          DO j = 1, resol
+             yorig = ymin + (ymax-ymin) * (j-.5_wp) / resol
+
+             dz1 = 0._wp
+             dz2 = boxsize(1)/uvec(1)
+
+             IF ( uvec(2) > 0._wp )  THEN
+                dy1 = -yorig             / uvec(2) !< crossing with y=0
+                dy2 = (boxsize(2)-yorig) / uvec(2) !< crossing with y=boxsize(2)
+             ELSE !uvec(2)==0
+                dy1 = -huge(1._wp)
+                dy2 = huge(1._wp)
+             ENDIF
+
+             IF ( uvec(3) > 0._wp )  THEN
+                dx1 = -xorig             / uvec(3) !< crossing with x=0
+                dx2 = (boxsize(3)-xorig) / uvec(3) !< crossing with x=boxsize(3)
+             ELSE !uvec(3)==0
+                dx1 = -huge(1._wp)
+                dx2 = huge(1._wp)
+             ENDIF
+
+             crdist = max(0._wp, (min(dz2, dy2, dx2) - max(dz1, dy1, dx1)))
+             transp = transp + exp(-ext_coef * dens * crdist)
+          ENDDO
+       ENDDO
+       transp = transp / resol**2
+       area = (boxsize(3)+xshift)*(boxsize(2)+yshift)
+       absorb = 1._wp - transp
+
+    END SUBROUTINE box_absorb
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine splits direct and diffusion dw radiation
+!> It sould not be called in case the radiation model already does it
+!> It follows <CITATION>
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_diffusion_radiation 
+    
+        REAL(wp), PARAMETER                          :: lowest_solarUp = 0.1_wp  !< limit the sun elevation to protect stability of the calculation
+        INTEGER(iwp)                                 :: i, j
+        REAL(wp)                                     ::  year_angle              !< angle
+        REAL(wp)                                     ::  etr                     !< extraterestrial radiation
+        REAL(wp)                                     ::  corrected_solarUp       !< corrected solar up radiation
+        REAL(wp)                                     ::  horizontalETR           !< horizontal extraterestrial radiation
+        REAL(wp)                                     ::  clearnessIndex          !< clearness index
+        REAL(wp)                                     ::  diff_frac               !< diffusion fraction of the radiation
+
+        
+!--     Calculate current day and time based on the initial values and simulation time
+        year_angle = ( (day_of_year_init * 86400) + time_utc_init              &
+                        + time_since_reference_point )  * d_seconds_year       &
+                        * 2.0_wp * pi
+        
+        etr = solar_constant * (1.00011_wp +                                   &
+                          0.034221_wp * cos(year_angle) +                      &
+                          0.001280_wp * sin(year_angle) +                      &
+                          0.000719_wp * cos(2.0_wp * year_angle) +             &
+                          0.000077_wp * sin(2.0_wp * year_angle))
+        
+!--    
+!--     Under a very low angle, we keep extraterestrial radiation at
+!--     the last small value, therefore the clearness index will be pushed
+!--     towards 0 while keeping full continuity.
+!--    
+        IF ( zenith(0) <= lowest_solarUp )  THEN
+            corrected_solarUp = lowest_solarUp
+        ELSE
+            corrected_solarUp = zenith(0)
+        ENDIF
+        
+        horizontalETR = etr * corrected_solarUp
+        
+        DO i = nxl, nxr
+            DO j = nys, nyn
+                clearnessIndex = rad_sw_in(0,j,i) / horizontalETR
+                diff_frac = 1.0_wp / (1.0_wp + exp(-5.0033_wp + 8.6025_wp * clearnessIndex))
+                rad_sw_in_diff(j,i) = rad_sw_in(0,j,i) * diff_frac
+                rad_sw_in_dir(j,i)  = rad_sw_in(0,j,i) * (1.0_wp - diff_frac)
+                rad_lw_in_diff(j,i) = rad_lw_in(0,j,i)
+            ENDDO
+        ENDDO
+        
+    END SUBROUTINE calc_diffusion_radiation
+
+
+ END SUBROUTINE radiation_interaction
+    
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This subroutine initializes structures needed for radiative transfer
+!> model. This model calculates transformation processes of the
+!> radiation inside urban and land canopy layer. The module includes also
+!> the interaction of the radiation with the resolved plant canopy.
+!>
+!> For more info. see Resler et al. 2017
+!>
+!> The new version 2.0 was radically rewriten, the discretization scheme
+!> has been changed. This new version significantly improves effectivity
+!> of the paralelization and the scalability of the model.
+!>
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_interaction_init
-    
+
        USE netcdf_data_input_mod,                                              &
            ONLY:  leaf_area_density_f
 
-       USE plant_canopy_model_mod,                                             &      
-           ONLY:  pch_index, pc_heating_rate, lad_s, prototype_lad, usm_lad_rma       
-       
+       USE plant_canopy_model_mod,                                             &
+           ONLY:  pch_index, pc_heating_rate, lad_s
+
        IMPLICIT NONE
 
